import { DynamicModule } from "@nestjs/common";
import { Entity } from "dynamodb-toolbox";
import { SchemaType } from "dynamodb-toolbox/dist/classes/Entity";
import { AsyncEntityFactory } from "./interfaces/async-entity-factory.interface";
import { DynamoDBToolboxModuleAsyncOptions, DynamoDBToolboxModuleOptions } from "./interfaces/dynamodb-toolbox-options.interface";
export declare class DynamoDBToolboxModule {
    static forRoot(options: DynamoDBToolboxModuleOptions): DynamicModule;
    static forRootAsync(options: DynamoDBToolboxModuleAsyncOptions): DynamicModule;
    static forFeature(entities?: Array<Entity<SchemaType>>): DynamicModule;
    static forFeatureAsync(factories?: AsyncEntityFactory[]): DynamicModule;
}
