"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var DynamoDBToolboxModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.DynamoDBToolboxModule = void 0;
const common_1 = require("@nestjs/common");
const dynamodb_toolbox_core_module_1 = require("./dynamodb-toolbox-core.module");
const dynamodb_toolbox_provider_1 = require("./dynamodb-toolbox.provider");
let DynamoDBToolboxModule = DynamoDBToolboxModule_1 = class DynamoDBToolboxModule {
    static forRoot(options) {
        return {
            module: DynamoDBToolboxModule_1,
            imports: [dynamodb_toolbox_core_module_1.DynamoDBToolboxCoreModule.forRoot(options)],
        };
    }
    static forRootAsync(options) {
        return {
            module: DynamoDBToolboxModule_1,
            imports: [dynamodb_toolbox_core_module_1.DynamoDBToolboxCoreModule.forRootAsync(options)],
        };
    }
    static forFeature(entities = []) {
        const providers = (0, dynamodb_toolbox_provider_1.createDynamodbProviders)(entities);
        return {
            module: DynamoDBToolboxModule_1,
            providers: providers,
            exports: providers,
        };
    }
    static forFeatureAsync(factories = []) {
        const providers = (0, dynamodb_toolbox_provider_1.createDynamooseAsyncProviders)(factories);
        const imports = factories.map((factory) => factory.imports || []);
        const uniqImports = new Set((0, common_1.flatten)(imports));
        return {
            module: DynamoDBToolboxModule_1,
            imports: [...uniqImports],
            providers: providers,
            exports: providers,
        };
    }
};
DynamoDBToolboxModule = DynamoDBToolboxModule_1 = __decorate([
    (0, common_1.Module)({})
], DynamoDBToolboxModule);
exports.DynamoDBToolboxModule = DynamoDBToolboxModule;
