import { Table } from "dynamodb-toolbox";
import { Entity } from "dynamodb-toolbox";
import { SchemaType } from "dynamodb-toolbox/dist/classes/Entity";
import { AsyncEntityFactory } from "./interfaces/async-entity-factory.interface";
export declare function createDynamodbProviders(entities?: Array<Entity<SchemaType>>): {
    provide: string;
    useFactory: (table: Table) => Entity<SchemaType>;
    inject: string[];
}[];
export declare function createDynamooseAsyncProviders(entityFactories?: AsyncEntityFactory[]): {
    provide: string;
    useFactory: (...args: unknown[]) => Promise<AsyncEntityFactory>;
    inject: any[];
}[];
